// File: Algorithm-3-2.cpp
// Stan Warford
// September 2020

#include <cstdlib>
#include <iostream>
#include <thread>
#include "Util450.cpp"
using namespace std;

volatile int n = 0;
volatile int turn = 1;

void pRun() {
    int temp;
    for (int i = 0; i < 10; i++) {
        // cout << "p.i == " << i << endl;
        randomDelay(10);
        // Preprotocol
        while (turn != 1)
            ;
        // Critical section
        temp = n;
        randomDelay(10);
        n = temp + 1;
        // Postprotocol
        turn = 2;
    }
}

void qRun() {
    int temp;
    for (int i = 0; i < 10; i++) {
        // cout << "q.i == " << i << endl;
        randomDelay(10);
        // Preprotocol
        while (turn != 2)
            ;
        // Critical section
        temp = n;
        randomDelay(10);
        n = temp + 1;
        // Postprotocol
        turn = 1;
    }
}

int main() {
    thread p(pRun);
    thread q(qRun);
    p.join();
    q.join();
    cout << "The value of n is " << n << endl;
    return EXIT_SUCCESS;
}
