// Stan Warford
// File: CountA.cpp
// September 2020

#include <cstdlib>
#include <iostream>
#include <thread>
using namespace std;

volatile int n = 0;

void pRun(int m) {
    int temp;
    for (int i = 0; i < m; i++) {
        temp = n;
        n = temp + 1;
    }
}

void qRun(int m) {
    int temp;
    for (int i = 0; i < m; i++) {
        temp = n;
        n = temp + 1;
    }
}

int main(int argc, char **argv) {
    int myMax = stoi(argv[1]);
    cout << "The value of myMax is " << myMax << endl;
    thread p(pRun, myMax);
    thread q(qRun, myMax);
    p.join();
    q.join();
    cout << "The value of n should be " << 2 * myMax << endl;
    cout << "The value of n is " << n << endl;
    return EXIT_SUCCESS;
}
